#!perl -W

use warnings;
use XML::LibXML;

my $top_srcdir=shift @ARGV;

$top_srcdir=".." if(not defined $top_srcdir);

my@grammar=XML::LibXML->new->parse_file ("$top_srcdir/admstpath.xml")->getDocumentElement->findnodes("/admstpath");
my$document=$grammar[0]->ownerDocument->getDocumentElement;
my@regexp=$document->findnodes("/admstpath/lex/regexp");
my@terminal=$document->findnodes("/admstpath/lex/terminal");
my@constant=$document->findnodes("/admstpath/lex/constant");
my@ignore=$document->findnodes("/admstpath/lex/ignore");
my@productionset=$document->findnodes("/admstpath/yacc/productionset");
my@code=$document->findnodes("/admstpath/yacc/code");
my%terminal;
my%constant;
map{$terminal{$_->getAttribute("id")}=1;} @terminal;
map{$constant{$_->getAttribute("id")}=1;} @constant;

open CFILE,">admstpath.dtd";
my$dtd=q[
<?xml version="1.0" encoding="UTF-8"?>
<!-- Spec interne d'un chemin 'admstpath'. Validation: xmllint dbgp.xml -noout -postvalid -noblanks --> 

<!--
  Fichier dbgp.xml
  <?xml version="1.0"?>
  <!--?xml-stylesheet type="text/xsl" href="admsstyle.xsl"?-->
  <!DOCTYPE admstpath SYSTEM "admstpath.dtd">
  <!-- Exemple de donnees 'admstpath' -->
  <admstpath>
  <!-- inserer ici les elements <p/> -->
  </admstpath>
-->
  
<!ENTITY % l '(r00?,(l00|l01|l02|l03|l04|l05|l06|l07|l08|l09|l10|l11|l12|l13|l14|l15|l16|l17|l18|l19|l20|l21|l22|l23|l24|l25|l26|l27|l28|l29|l30)*)'>
<!ENTITY % u '(u00|u01|u02|u03|u04|u05|u06|u07|u08|u09),(b00|b01)?'>
<!ELEMENT admstpath (p+) >
<!ELEMENT p (top) >
<!ELEMENT top %l; >
<!ELEMENT l00 (c00?) >
<!ELEMENT l01 (c00?) >
<!ELEMENT l02 (c00?) >
<!ELEMENT l03 (top,c00?) >
<!ELEMENT l04 (c00?) >
<!ELEMENT l05 (c00?) >
<!ELEMENT l06 (c00?) >
<!ELEMENT l07 (c00?) >
<!ELEMENT l08 (c00?) >
<!ELEMENT l09 (c00?) >
<!ELEMENT l10 (c00?) >
<!ELEMENT l11 (c00?) >
<!ELEMENT l12 (c00?) >
<!ELEMENT l13 (c00?) >
<!ELEMENT l14 (c00?) >
<!ELEMENT l15 (c00?) >
<!ELEMENT l16 (c00?) >
<!ELEMENT l17 (c00?) >
<!ELEMENT l18 (top,c00?) >
<!ELEMENT l19 (top,c00?) >
<!ELEMENT l20 (top,top,c00?) >
<!ELEMENT l21 (top,c00?) >
<!ELEMENT l22 (top,c00?) >
<!ELEMENT l23 (top,c00?) >
<!ELEMENT l24 (top,c00?) >
<!ELEMENT l25 (top,c00?) >
<!ELEMENT l26 (top,c00?) >
<!ELEMENT l27 (top,c00?) >
<!ELEMENT l28 (top,top,c00?) >
<!ELEMENT l29 (top,c00?) >
<!ELEMENT l30 (c00?) >
<!ELEMENT c00 (%u;) >
<!ELEMENT b00 (%u;) >
<!ELEMENT b01 (%u;) >
<!ELEMENT u00 (top) >
<!ELEMENT u01 (top) >
<!ELEMENT u02 EMPTY >
<!ELEMENT u03 (c00) >
<!ELEMENT u04 EMPTY >
<!ELEMENT u05 EMPTY >
<!ELEMENT u06 (c00) >
<!ELEMENT u07 EMPTY >
<!ELEMENT u08 (top,top) >
<!ELEMENT u09 (top,top) >
<!ATTLIST p id CDATA #REQUIRED >
];
print CFILE $dtd;
close CFILE;
print "admstpath.dtd: created\n";

#ICI
open CFILE,">admstpath.c";
print CFILE q[/* ------- code automatically created by mkadmstpath.pl -------------- */ ];
my%location=(
'position' =>
q[
  FORBEGIN
    MKADMSTNEW(adms_integer_new(myadmst->_index))
  FOREND
],
'positionplus' =>
q[
  int offset=+adms_strtol(tsprintf(NULL,mypath->_text),mypath->_transform);
  FORBEGIN
    MKADMSTNEW(adms_integer_new(myadmst->_index+offset))
  FOREND
],
'positionminus' =>
q[
  int offset=-adms_strtol(tsprintf(NULL,mypath->_text),mypath->_transform);
  FORBEGIN
    MKADMSTNEW(adms_integer_new(myadmst->_index+offset))
  FOREND
],
'posinteger' =>
q[
  int offset=+adms_strtol(tsprintf(NULL,mypath->_text),mypath->_transform);
  FORBEGIN
    MKADMSTNEW(adms_integer_new(offset))
  FOREND
],
'neginteger' =>
q[
  int offset=-adms_strtol(tsprintf(NULL,mypath->_text),mypath->_transform);
  FORBEGIN
    MKADMSTNEW(adms_integer_new(offset))
  FOREND
],
'posreal' =>
q[
  double offset=adms_strtod(tsprintf(NULL,mypath->_text));
  FORBEGIN
    MKADMSTNEW(adms_real_new(offset))
  FOREND
],
'negreal' =>
q[
  double offset=-adms_strtod(tsprintf(NULL,mypath->_text));
  FORBEGIN
    MKADMSTNEW(adms_real_new(offset))
  FOREND
],
'count' =>
q[
  int mycount;
  int isrelative= ((adms_path(adms_path(mypath->_y->data)->_y->data)->_callback==l00)
                 ||(adms_path(adms_path(mypath->_y->data)->_y->data)->_callback==l01))
                 &&(adms_path(adms_path(mypath->_y->data)->_y->data)->_y==NULL);
  FORBEGIN
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    if(isrelative)
      mycount=adms_admst(mysubptraverse0->_admst->data)->_count;
    else
      mycount=adms_slist_length((mysubptraverse0->_admst));
    MKADMSTNEW(adms_integer_new(mycount))
    free_ptraverse(0,mysubptraverse0);
  FOREND
],
'index' =>
q[
  FORBEGIN
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_ptraverse mysubptraverse1=ptraverse(0,myadmst,adms_path(mypath->_y->next->data));
    p_slist mylii;
    for(mylii=(mysubptraverse1->_admst);mylii;mylii=mylii->next)
    {
      p_adms myadms1=mylii->data?adms_admst(mylii->data)->_item:NULL;
      p_slist myl0;
      int myindex=-1;
      int found=0;
      for(myl0=(mysubptraverse0->_admst);myl0&&!found;myl0=myl0->next)
      {
        p_adms myadms0=myl0->data?adms_admst(myl0->data)->_item:NULL;
        found=(myadms0==myadms1);
        myindex++;
      }
      if(found)
        MKADMSTNEW(adms_integer_new(myindex))
      else
        MKADMSTNEW(adms_integer_new(-1))
    }
    free_ptraverse(0,mysubptraverse0);
    free_ptraverse(0,mysubptraverse1);
  FOREND
],
'quotedstring' =>
q[
  FORBEGIN
    if(mypath->_text->_toptype==admse__constant)
      MKADMST(mypath->_text->_token->data)
    else
    {
      p_str myquotedstring_0=tsprintf(myadmst,mypath->_text);
      MKADMSTNEW(adms_quark_new(myquotedstring_0))
      free(myquotedstring_0);
    }
  FOREND
],
'id' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=mysubptraverse0->_admst;
    for(;myl0;myl0=myl0->next)
    {
      p_str mystring=malloc(sizeof(char)*50);
      sprintf(mystring,"%p",adms_admst(myl0->data)->_item);
      if(prev)
         prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      adms_admst(myl0->data)->_item=adms_adms(adms_quark_new(mystring));
      adms_admst(myl0->data)->_hasnewitem=1;
      prev=myl0;
      free(mystring);
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'uid' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=mysubptraverse0->_admst;
    for(;myl0;myl0=myl0->next)
    {
      p_str mystring=aprintf(mypath->_transform,adms_admst(myl0->data));
      if(prev)
         prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      adms_admst(myl0->data)->_item=adms_adms(adms_quark_new(mystring));
      adms_admst(myl0->data)->_hasnewitem=1;
      prev=myl0;
      free(mystring);
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'upper_case' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=mysubptraverse0->_admst;
    for(;myl0;myl0=myl0->next)
    {
      p_str mystring=aprintf(mypath->_transform,adms_admst(myl0->data));
      adms_toupper(mystring);
      if(prev)
         prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      adms_admst(myl0->data)->_item=adms_adms(adms_quark_new(mystring));
      adms_admst(myl0->data)->_hasnewitem=1;
      prev=myl0;
      free(mystring);
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'lower_case' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=mysubptraverse0->_admst;
    for(;myl0;myl0=myl0->next)
    {
      p_str mystring=aprintf(mypath->_transform,adms_admst(myl0->data));
      adms_tolower(mystring);
      if(prev)
         prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      adms_admst(myl0->data)->_item=adms_adms(adms_quark_new(mystring));
      adms_admst(myl0->data)->_hasnewitem=1;
      prev=myl0;
      free(mystring);
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'sort' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=adms_slist_sort(mysubptraverse0->_admst);
    for(;myl0;myl0=myl0->next)
    {
      if(prev)
        prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      prev=myl0;
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'reverse' =>
q[
  FORBEGIN-NULL
    p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
    p_slist myl0=adms_slist_reverse(mysubptraverse0->_admst);
    for(;myl0;myl0=myl0->next)
    {
      if(prev)
        prev->next=myl0;
      else
        myptraverse->_admst=myl0;
      adms_admst(myl0->data)->_index=++count;;
      prev=myl0;
    }
    adms_slist_concat(&myptraverse->_alladmst,mysubptraverse0->_alladmst);
    if(prev)
      prev->next=NULL;
    free(mysubptraverse0);
  FOREND
],
'string' => 0,
'number' => 0,
'contains' => 0,
'text' => 0,
'admst' =>
q[
  FORBEGIN
    MKADMST(myadmst)
  FOREND
],
'croix' =>
q[
  FORBEGIN
    MKADMST(lookup_croix(myadmst,tsprintf(myadmst,mypath->_text)))
  FOREND
],
'returned' =>
q[
  if(root()->_itransforminsideapplytemplate)
  {
    FORBEGIN
      p_str myname=tsprintf(myadmst,mypath->_text);
      p_itransform myitransform=adms_itransform(root()->_itransforminsideapplytemplate->data);
      p_admst d=NULL;
      p_slist list=myitransform->_return;
      while(list&&!d)
      {
        p_return refreturn=(p_return)((p_admst)list->data)->_item;
        if(!strcmp(refreturn->_name->_value,myname))
          d=(p_admst)list->data;
        list=list->next;
      }
      if(d==NULL)
      {
        adms_message_fatal_continue(("returned('%s'): undefined returned value\n",myname))
        adms_message_fatal(("see %s\n",adms_transform_uid(mypath->_transform)))
      }
      d->_index=++count;
      myli->data=adms_adms(d);
      free(myname);
    FOREND
  }
  else
  {
    p_transform mytransform=mypath->_transform;
    adms_message_fatal_continue(("return(.) allowed only inside admst:apply-templates\n"))
    adms_message_fatal(("see %s\n",adms_transform_uid(mytransform)))
  }
],
'star' => 0,
);

my$l04=q[
  IFIDENT(OPdependent)
    MKSCALAR(variable,OPdependent)
  ENDIFIDENT
  IFIDENT(TemperatureDependent)
    MKSCALAR(expression,TemperatureDependent)
    MKSCALAR(variable,TemperatureDependent)
  ENDIFIDENT
  IFIDENT(abstol)
    MKSCALAR(nature,abstol)
  ENDIFIDENT
  IFIDENT(access)
    MKSCALAR(nature,access)
  ENDIFIDENT
  IFIDENT(adms)
    MKSUBADMS(admsmain,adms)
    MKSUBADMS(analog,adms)
    MKSUBADMS(analogfunction,adms)
    MKSUBADMS(assignment,adms)
    MKSUBADMS(attribute,adms)
    MKSUBADMS(block,adms)
    MKSUBADMS(blockvariable,adms)
    MKSUBADMS(branch,adms)
    MKSUBADMS(branchalias,adms)
    MKSUBADMS(callfunction,adms)
    MKSUBADMS(case,adms)
    MKSUBADMS(caseitem,adms)
    MKSUBADMS(conditional,adms)
    MKSUBADMS(contribution,adms)
    MKSUBADMS(discipline,adms)
    MKSUBADMS(enumeration,adms)
    MKSUBADMS(evaluation,adms)
    MKSUBADMS(expression,adms)
    MKSUBADMS(forloop,adms)
    MKSUBADMS(function,adms)
    MKSUBADMS(instance,adms)
    MKSUBADMS(instancenode,adms)
    MKSUBADMS(instanceparameter,adms)
    MKSUBADMS(integer,adms)
    MKSUBADMS(jacobian,adms)
    MKSUBADMS(list,adms)
    MKSUBADMS(mapply_binary,adms)
    MKSUBADMS(mapply_ternary,adms)
    MKSUBADMS(mapply_unary,adms)
    MKSUBADMS(math,adms)
    MKSUBADMS(module,adms)
    MKSUBADMS(nature,adms)
    MKSUBADMS(nilled,adms)
    MKSUBADMS(node,adms)
    MKSUBADMS(nodealias,adms)
    MKSUBADMS(number,adms)
    MKSUBADMS(probe,adms)
    MKSUBADMS(quark,adms)
    MKSUBADMS(range,adms)
    MKSUBADMS(real,adms)
    MKSUBADMS(simulator,adms)
    MKSUBADMS(source,adms)
    MKSUBADMS(string,adms)
    MKSUBADMS(subexpression,adms)
    MKSUBADMS(variable,adms)
    MKSUBADMS(whileloop,adms)
  ENDIFIDENT
  IFIDENT(alias)
    MKLIST(variable,alias)
  ENDIFIDENT
  IFIDENT(analog)
    MKSCALAR(module,analog)
  ENDIFIDENT
  IFIDENT(analogfunction)
    MKLIST(module,analogfunction)
  ENDIFIDENT
  IFIDENT(arg1)
    MKSCALAR(mapply_binary,arg1)
    MKSCALAR(mapply_ternary,arg1)
    MKSCALAR(mapply_unary,arg1)
  ENDIFIDENT
  IFIDENT(arg2)
    MKSCALAR(mapply_binary,arg2)
    MKSCALAR(mapply_ternary,arg2)
  ENDIFIDENT
  IFIDENT(arg3)
    MKSCALAR(mapply_ternary,arg3)
  ENDIFIDENT
  IFIDENT(argc)
    MKBASICINTEGER(admsmain,argc)
  ENDIFIDENT
  IFIDENT(arguments)
    MKLIST(function,arguments)
  ENDIFIDENT
  IFIDENT(argv)
    MKLIST(admsmain,argv)
  ENDIFIDENT
  IFIDENT(assignment)
    MKLIST(module,assignment)
    MKLIST(variable,assignment)
  ENDIFIDENT
  IFIDENT(attribute)
    MKLIST(assignment,attribute)
    MKLIST(block,attribute)
    MKLIST(branch,attribute)
    MKLIST(contribution,attribute)
    MKLIST(math,attribute)
    MKLIST(module,attribute)
    MKLIST(node,attribute)
    MKLIST(source,attribute)
    MKLIST(variable,attribute)
  ENDIFIDENT
  IFIDENT(base)
    MKSCALAR(nature,base)
  ENDIFIDENT
  IFIDENT(block)
    MKLIST(module,block)
    MKSCALAR(block,block)
    MKSCALAR(blockvariable,block)
    MKSCALAR(variable,block)
  ENDIFIDENT
  IFIDENT(blockvariable)
    MKLIST(module,blockvariable)
  ENDIFIDENT
  IFIDENT(br1)
    MKSCALAR(simulator,br1)
  ENDIFIDENT
  IFIDENT(br2)
    MKSCALAR(simulator,br2)
  ENDIFIDENT
  IFIDENT(branch)
    MKLIST(module,branch)
    MKSCALAR(branchalias,branch)
    MKSCALAR(probe,branch)
    MKSCALAR(source,branch)
  ENDIFIDENT
  IFIDENT(branchalias)
    MKLIST(module,branchalias)
    MKSCALAR(contribution,branchalias)
  ENDIFIDENT
  IFIDENT(case)
    MKSCALAR(case,case)
  ENDIFIDENT
  IFIDENT(caseitem)
    MKLIST(case,caseitem)
  ENDIFIDENT
  IFIDENT(class)
    MKSCALAR(function,class)
  ENDIFIDENT
  IFIDENT(code)
    MKSCALAR(analog,code)
    MKSCALAR(caseitem,code)
  ENDIFIDENT
  IFIDENT(column)
    MKSCALAR(jacobian,column)
  ENDIFIDENT
  IFIDENT(condition)
    MKLIST(caseitem,condition)
    MKSCALAR(forloop,condition)
  ENDIFIDENT
  IFIDENT(conditional)
    MKLIST(module,conditional)
  ENDIFIDENT
  IFIDENT(contribution)
    MKLIST(module,contribution)
  ENDIFIDENT
  IFIDENT(curline)
    MKSCALAR(admsmain,curline)
  ENDIFIDENT
  IFIDENT(currentdate)
    MKSCALAR(simulator,currentdate)
  ENDIFIDENT
  IFIDENT(datatype)
    MKSCALAR(list,datatype)
  ENDIFIDENT
  IFIDENT(dbg_mem)
    MKSCALAR(admsmain,dbg_mem)
  ENDIFIDENT
  IFIDENT(dbg_vla)
    MKSCALAR(admsmain,dbg_vla)
  ENDIFIDENT
  IFIDENT(dbg_xml)
    MKSCALAR(admsmain,dbg_xml)
  ENDIFIDENT
  IFIDENT(ddtNature)
    MKSCALAR(nature,ddtNature)
  ENDIFIDENT
  IFIDENT(ddx)
    MKSCALAR(simulator,ddx)
  ENDIFIDENT
  IFIDENT(ddxprobe)
    MKLIST(variable,ddxprobe)
  ENDIFIDENT
  IFIDENT(debug)
    MKSCALAR(admsmain,debug)
  ENDIFIDENT
  IFIDENT(default)
    MKSCALAR(variable,default)
  ENDIFIDENT
  IFIDENT(defaultcase)
    MKSCALAR(caseitem,defaultcase)
  ENDIFIDENT
  IFIDENT(definition)
    MKSCALAR(function,definition)
  ENDIFIDENT
  IFIDENT(dependency)
    MKSCALAR(math,dependency)
  ENDIFIDENT
  IFIDENT(derivate)
    MKSCALAR(variable,derivate)
  ENDIFIDENT
  IFIDENT(developer)
    MKSCALAR(simulator,developer)
  ENDIFIDENT
  IFIDENT(diagonal)
    MKSCALAR(jacobian,diagonal)
  ENDIFIDENT
  IFIDENT(direction)
    MKSCALAR(node,direction)
  ENDIFIDENT
  IFIDENT(discipline)
    MKLIST(admsmain,discipline)
    MKSCALAR(branch,discipline)
    MKSCALAR(node,discipline)
    MKSCALAR(probe,discipline)
    MKSCALAR(source,discipline)
  ENDIFIDENT
  IFIDENT(dynamic)
    MKALIAS(assignment,dynamic,math,dynamic)
    MKALIAS(block,dynamic,math,dynamic)
    MKALIAS(blockvariable,dynamic,math,dynamic)
    MKALIAS(callfunction,dynamic,math,dynamic)
    MKALIAS(case,dynamic,math,dynamic)
    MKALIAS(conditional,dynamic,math,dynamic)
    MKALIAS(contribution,dynamic,math,dynamic)
    MKALIAS(expression,dynamic,math,dynamic)
    MKALIAS(forloop,dynamic,math,dynamic)
    MKALIAS(nilled,dynamic,math,dynamic)
    MKALIAS(variable,dynamic,math,dynamic)
    MKALIAS(whileloop,dynamic,math,dynamic)
    MKSCALAR(jacobian,dynamic)
    MKSCALAR(math,dynamic)
    MKSCALAR(source,dynamic)
  ENDIFIDENT
  IFIDENT(else)
    MKSCALAR(conditional,else)
  ENDIFIDENT
  IFIDENT(error)
    MKSCALAR(admsmain,error)
  ENDIFIDENT
  IFIDENT(evaluation)
    MKSCALAR(module,evaluation)
  ENDIFIDENT
  IFIDENT(expression)
    MKLIST(module,expression)
    MKSCALAR(subexpression,expression)
  ENDIFIDENT
  IFIDENT(fatal)
    MKSCALAR(admsmain,fatal)
  ENDIFIDENT
  IFIDENT(filename)
    MKSCALAR(admsmain,filename)
  ENDIFIDENT
  IFIDENT(flickernoise)
    MKSCALAR(contribution,flickernoise)
    MKSCALAR(source,flickernoise)
  ENDIFIDENT
  IFIDENT(flow)
    MKSCALAR(discipline,flow)
  ENDIFIDENT
  IFIDENT(forblock)
    MKSCALAR(forloop,forblock)
  ENDIFIDENT
  IFIDENT(fpos)
    MKSCALAR(admsmain,fpos)
  ENDIFIDENT
  IFIDENT(fullname)
    MKSCALAR(simulator,fullname)
  ENDIFIDENT
  IFIDENT(function)
    MKLIST(expression,function)
    MKSCALAR(callfunction,function)
  ENDIFIDENT
  IFIDENT(grounded)
    MKSCALAR(branch,grounded)
    MKSCALAR(node,grounded)
    MKSCALAR(probe,grounded)
    MKSCALAR(source,grounded)
  ENDIFIDENT
  IFIDENT(hasVoltageDependentFunction)
    MKSCALAR(expression,hasVoltageDependentFunction)
  ENDIFIDENT
  IFIDENT(hasspecialnumber)
    MKSCALAR(expression,hasspecialnumber)
  ENDIFIDENT
  IFIDENT(hint)
    MKSCALAR(admsmain,hint)
  ENDIFIDENT
  IFIDENT(idtNature)
    MKSCALAR(nature,idtNature)
  ENDIFIDENT
  IFIDENT(if)
    MKSCALAR(conditional,if)
  ENDIFIDENT
  IFIDENT(infboundtype)
    MKSCALAR(range,infboundtype)
  ENDIFIDENT
  IFIDENT(infexpr)
    MKSCALAR(range,infexpr)
  ENDIFIDENT
  IFIDENT(info)
    MKSCALAR(admsmain,info)
  ENDIFIDENT
  IFIDENT(initial)
    MKSCALAR(forloop,initial)
  ENDIFIDENT
  IFIDENT(input)
    MKSCALAR(variable,input)
  ENDIFIDENT
  IFIDENT(insource)
    MKSCALAR(variable,insource)
  ENDIFIDENT
  IFIDENT(instance)
    MKLIST(module,instance)
  ENDIFIDENT
  IFIDENT(itransform)
    MKLIST(admsmain,itransform)
  ENDIFIDENT
  IFIDENT(itransforminsideapplytemplate)
    MKLIST(admsmain,itransforminsideapplytemplate)
  ENDIFIDENT
  IFIDENT(instantiator)
    MKLIST(module,instantiator)
    MKSCALAR(instance,instantiator)
  ENDIFIDENT
  IFIDENT(isstate)
    MKSCALAR(variable,isstate)
  ENDIFIDENT
  IFIDENT(item)
    MKLIST(block,item)
    MKLIST(list,item)
  ENDIFIDENT
  IFIDENT(jacobian)
    MKLIST(module,jacobian)
  ENDIFIDENT
  IFIDENT(lhs)
    MKSCALAR(assignment,lhs)
    MKSCALAR(contribution,lhs)
  ENDIFIDENT
  IFIDENT(location)
    MKSCALAR(node,location)
  ENDIFIDENT
  IFIDENT(math)
    MKSUBADMS(assignment,math)
    MKSUBADMS(block,math)
    MKSUBADMS(blockvariable,math)
    MKSUBADMS(callfunction,math)
    MKSUBADMS(case,math)
    MKSUBADMS(caseitem,math)
    MKSUBADMS(conditional,math)
    MKSUBADMS(contribution,math)
    MKSUBADMS(expression,math)
    MKSUBADMS(forloop,math)
    MKSUBADMS(function,math)
    MKSUBADMS(instance,math)
    MKSUBADMS(instancenode,math)
    MKSUBADMS(instanceparameter,math)
    MKSUBADMS(mapply_binary,math)
    MKSUBADMS(mapply_ternary,math)
    MKSUBADMS(mapply_unary,math)
    MKSUBADMS(nilled,math)
    MKSUBADMS(number,math)
    MKSUBADMS(probe,math)
    MKSUBADMS(string,math)
    MKSUBADMS(subexpression,math)
    MKSUBADMS(variable,math)
    MKSUBADMS(whileloop,math)
  ENDIFIDENT
  IFIDENT(maxsize)
    MKSCALAR(variable,maxsize)
  ENDIFIDENT
  IFIDENT(minsize)
    MKSCALAR(variable,minsize)
  ENDIFIDENT
  IFIDENT(module)
    MKLIST(admsmain,module)
    MKSCALAR(analogfunction,module)
    MKSCALAR(assignment,module)
    MKSCALAR(block,module)
    MKSCALAR(branch,module)
    MKSCALAR(branchalias,module)
    MKSCALAR(callfunction,module)
    MKSCALAR(case,module)
    MKSCALAR(conditional,module)
    MKSCALAR(contribution,module)
    MKSCALAR(expression,module)
    MKSCALAR(forloop,module)
    MKSCALAR(instance,module)
    MKSCALAR(jacobian,module)
    MKSCALAR(nilled,module)
    MKSCALAR(node,module)
    MKSCALAR(nodealias,module)
    MKSCALAR(probe,module)
    MKSCALAR(range,module)
    MKSCALAR(source,module)
    MKSCALAR(variable,module)
    MKSCALAR(whileloop,module)
  ENDIFIDENT
  IFIDENT(name)
    MKSCALAR(admsmain,name)
    MKSCALAR(analogfunction,name)
    MKSCALAR(assignment,name)
    MKRETURNED(return,name)
    MKALIASSCALAR(return,name,_returnedname,name)
    MKALIASSCALAR(return,name,_returnedvalue,name)
    MKSCALAR(attribute,name)
    MKSCALAR(block,name)
    MKSCALAR(branchalias,name)
    MKSCALAR(case,name)
    MKSCALAR(conditional,name)
    MKSCALAR(contribution,name)
    MKSCALAR(discipline,name)
    MKSCALAR(forloop,name)
    MKSCALAR(function,name)
    MKSCALAR(instance,name)
    MKSCALAR(mapply_binary,name)
    MKSCALAR(mapply_ternary,name)
    MKSCALAR(mapply_unary,name)
    MKSCALAR(math,name)
    MKSCALAR(module,name)
    MKSCALAR(nature,name)
    MKSCALAR(nilled,name)
    MKSCALAR(node,name)
    MKSCALAR(nodealias,name)
    MKSCALAR(range,name)
    MKSCALAR(simulator,name)
    MKSCALAR(variable,name)
    MKSCALAR(whileloop,name)
  ENDIFIDENT
  IFIDENT(nature)
    MKLIST(admsmain,nature)
    MKSCALAR(probe,nature)
    MKSCALAR(source,nature)
  ENDIFIDENT
  IFIDENT(nnode)
    MKSCALAR(branch,nnode)
  ENDIFIDENT
  IFIDENT(node)
    MKLIST(module,node)
    MKSCALAR(nodealias,node)
  ENDIFIDENT
  IFIDENT(nodealias)
    MKLIST(module,nodealias)
  ENDIFIDENT
  IFIDENT(nodefrominstantiator)
    MKSCALAR(instancenode,nodefrominstantiator)
  ENDIFIDENT
  IFIDENT(nodefrommodule)
    MKSCALAR(instancenode,nodefrommodule)
  ENDIFIDENT
  IFIDENT(obsolete)
    MKSCALAR(admsmain,obsolete)
  ENDIFIDENT
  IFIDENT(output)
    MKSCALAR(variable,output)
  ENDIFIDENT
  IFIDENT(package_bugreport)
    MKSCALAR(simulator,package_bugreport)
  ENDIFIDENT
  IFIDENT(package_name)
    MKSCALAR(simulator,package_name)
  ENDIFIDENT
  IFIDENT(package_string)
    MKSCALAR(simulator,package_string)
  ENDIFIDENT
  IFIDENT(package_tarname)
    MKSCALAR(simulator,package_tarname)
  ENDIFIDENT
  IFIDENT(package_version)
    MKSCALAR(simulator,package_version)
  ENDIFIDENT
  IFIDENT(parameter)
    MKSCALAR(instanceparameter,parameter)
  ENDIFIDENT
  IFIDENT(parameterset)
    MKLIST(instance,parameterset)
  ENDIFIDENT
  IFIDENT(parametertype)
    MKSCALAR(variable,parametertype)
  ENDIFIDENT
  IFIDENT(pnode)
    MKSCALAR(branch,pnode)
  ENDIFIDENT
  IFIDENT(potential)
    MKSCALAR(discipline,potential)
  ENDIFIDENT
  IFIDENT(probe)
    MKLIST(block,probe)
    MKLIST(expression,probe)
    MKLIST(module,probe)
    MKLIST(source,probe)
    MKLIST(variable,probe)
    MKSCALAR(simulator,probe)
  ENDIFIDENT
  IFIDENT(range)
    MKLIST(module,range)
    MKLIST(variable,range)
  ENDIFIDENT
  IFIDENT(rhs)
    MKSCALAR(assignment,rhs)
    MKSCALAR(contribution,rhs)
  ENDIFIDENT
  IFIDENT(row)
    MKSCALAR(jacobian,row)
  ENDIFIDENT
  IFIDENT(scalingunit)
    MKSCALAR(number,scalingunit)
  ENDIFIDENT
  IFIDENT(scope)
    MKSCALAR(variable,scope)
  ENDIFIDENT
  IFIDENT(seen)
    MKSCALAR(probe,seen)
  ENDIFIDENT
  IFIDENT(setinevaluate)
    MKSCALAR(variable,setinevaluate)
  ENDIFIDENT
  IFIDENT(setinfinal)
    MKSCALAR(variable,setinfinal)
  ENDIFIDENT
  IFIDENT(setingetprev)
    MKSCALAR(variable,setingetprev)
  ENDIFIDENT
  IFIDENT(setininitial_step)
    MKSCALAR(variable,setininitial_step)
  ENDIFIDENT
  IFIDENT(setininstance)
    MKSCALAR(variable,setininstance)
  ENDIFIDENT
  IFIDENT(setinmodel)
    MKSCALAR(variable,setinmodel)
  ENDIFIDENT
  IFIDENT(setinnoise)
    MKSCALAR(variable,setinnoise)
  ENDIFIDENT
  IFIDENT(simulator)
    MKSCALAR(admsmain,simulator)
  ENDIFIDENT
  IFIDENT(sizetype)
    MKSCALAR(variable,sizetype)
  ENDIFIDENT
  IFIDENT(source)
    MKLIST(module,source)
    MKSCALAR(probe,source)
  ENDIFIDENT
  IFIDENT(sr1)
    MKSCALAR(simulator,sr1)
  ENDIFIDENT
  IFIDENT(static)
    MKALIAS(assignment,static,math,static)
    MKALIAS(block,static,math,static)
    MKALIAS(blockvariable,static,math,static)
    MKALIAS(callfunction,static,math,static)
    MKALIAS(case,static,math,static)
    MKALIAS(conditional,static,math,static)
    MKALIAS(contribution,static,math,static)
    MKALIAS(expression,static,math,static)
    MKALIAS(forloop,static,math,static)
    MKALIAS(nilled,static,math,static)
    MKALIAS(variable,static,math,static)
    MKALIAS(whileloop,static,math,static)
    MKSCALAR(jacobian,static)
    MKSCALAR(math,static)
    MKSCALAR(source,static)
  ENDIFIDENT
  IFIDENT(subexpression)
    MKSUBADMS(function,subexpression)
    MKSUBADMS(mapply_binary,subexpression)
    MKSUBADMS(mapply_ternary,subexpression)
    MKSUBADMS(mapply_unary,subexpression)
    MKSUBADMS(number,subexpression)
    MKSUBADMS(probe,subexpression)
    MKSUBADMS(variable,subexpression)
  ENDIFIDENT
  IFIDENT(supboundtype)
    MKSCALAR(range,supboundtype)
  ENDIFIDENT
  IFIDENT(supexpr)
    MKSCALAR(range,supexpr)
  ENDIFIDENT
  IFIDENT(switch)
    MKSCALAR(source,switch)
  ENDIFIDENT
  IFIDENT(template)
    MKLIST(admsmain,template)
  ENDIFIDENT
  IFIDENT(terminal)
    MKLIST(instance,terminal)
  ENDIFIDENT
  IFIDENT(then)
    MKSCALAR(conditional,then)
  ENDIFIDENT
  IFIDENT(tmp)
    MKSCALAR(simulator,tmp)
  ENDIFIDENT
  IFIDENT(tmp1)
    MKSCALAR(simulator,tmp1)
  ENDIFIDENT
  IFIDENT(transform)
    MKLIST(admsmain,transform)
  ENDIFIDENT
  IFIDENT(tree)
    MKSCALAR(analogfunction,tree)
    MKSCALAR(expression,tree)
  ENDIFIDENT
  IFIDENT(type)
    MKSCALAR(analogfunction,type)
    MKSCALAR(range,type)
    MKSCALAR(source,type)
    MKSCALAR(variable,type)
  ENDIFIDENT
  IFIDENT(unique_id)
    MKSCALAR(function,unique_id)
  ENDIFIDENT
  IFIDENT(units)
    MKSCALAR(nature,units)
  ENDIFIDENT
  IFIDENT(update)
    MKSCALAR(forloop,update)
  ENDIFIDENT
  IFIDENT(usage)
    MKSCALAR(admsmain,usage)
  ENDIFIDENT
  IFIDENT(usedinevaluate)
    MKSCALAR(variable,usedinevaluate)
  ENDIFIDENT
  IFIDENT(usedinfinal)
    MKSCALAR(variable,usedinfinal)
  ENDIFIDENT
  IFIDENT(usedininitial_step)
    MKSCALAR(variable,usedininitial_step)
  ENDIFIDENT
  IFIDENT(usedininstance)
    MKSCALAR(variable,usedininstance)
  ENDIFIDENT
  IFIDENT(usedinmodel)
    MKSCALAR(variable,usedinmodel)
  ENDIFIDENT
  IFIDENT(usedinnoise)
    MKSCALAR(variable,usedinnoise)
  ENDIFIDENT
  IFIDENT(value)
    MKRETURNED(return,value)
    MKALIASSCALAR(return,value,_returnedname,value)
    MKALIASSCALAR(return,value,_returnedvalue,value)
    MKSCALAR(attribute,value)
    MKSCALAR(enumeration,value)
    MKSCALAR(expression,value)
    MKSCALAR(instanceparameter,value)
    MKSCALAR(integer,value)
    MKSCALAR(math,value)
    MKSCALAR(number,value)
    MKSCALAR(quark,value)
    MKREAL(real)
    MKSCALAR(string,value)
  ENDIFIDENT
  IFIDENT(valueof)
    MKLIST(admsmain,valueof)
  ENDIFIDENT
  IFIDENT(variable)
    MKLIST(admsmain,variable)
    MKLIST(analogfunction,variable)
    MKLIST(block,variable)
    MKLIST(blockvariable,variable)
    MKLIST(evaluation,variable)
    MKLIST(expression,variable)
    MKLIST(module,variable)
    MKLIST(variable,variable)
  ENDIFIDENT
  IFIDENT(vcount)
    MKSCALAR(variable,vcount)
  ENDIFIDENT
  IFIDENT(verbose)
    MKSCALAR(admsmain,verbose)
  ENDIFIDENT
  IFIDENT(vlast)
    MKSCALAR(variable,vlast)
  ENDIFIDENT
  IFIDENT(warning)
    MKSCALAR(admsmain,warning)
  ENDIFIDENT
  IFIDENT(while)
    MKSCALAR(whileloop,while)
  ENDIFIDENT
  IFIDENT(whileblock)
    MKSCALAR(whileloop,whileblock)
  ENDIFIDENT
  IFIDENT(whitenoise)
    MKSCALAR(contribution,whitenoise)
    MKSCALAR(source,whitenoise)
  ENDIFIDENT
];

sub list
{
print CFILE "_m_cblocation(Lquotedstringobsolete)
{
  p_slist myli=myptraverse->_admst;
  for(;myli;myli=myli->next)
  {
    p_admst mystack=adms_pull_admst(mypath->_transform);
    myli->data=adms_adms(mystack);
    adms_slist_push(&myptraverse->_alladmst,adms_adms(mystack));
  }
  lcond0(myptraverse,mypath);
}
_m_cblocation(Ldollar)
{
  if((mode==2)&&!mypath->_condition)
  {
    p_slist myli=myptraverse->_admst;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_str id=tsprintf(myadmst,mypath->_text);
      p_admstvariable dollar=lookup_dollar(id);
      p_admst mynewadmst=adms_admst_new(myadmst,adms_adms(dollar));
      if(!dollar)
        adms_message_fatal((\"%s: variable is undefined! see %s\\n\",id,adms_transform_uid(mypath->_transform)))
      free(id);
      mynewadmst->_pseudodatatype=admse__dlist;
      myli->data=(p_adms)mynewadmst;
      adms_slist_push(&myptraverse->_alladmst,(p_adms)mynewadmst);
    }
  }
  else
  {
    p_slist mylocation=NULL;
    p_slist myli=myptraverse->_admst;
    int count=0;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_slist mylii;
      p_str id=tsprintf(myadmst,mypath->_text);
      p_admstvariable dollar=lookup_dollar(id);
      if(!dollar)
        adms_message_fatal((\"%s: variable is undefined! see %s\\n\",id,adms_transform_uid(mypath->_transform)))
      free(id);
      for(mylii=dollar->_value;mylii;mylii=mylii->next)
      {
        p_admst d=adms_admst(mylii->data);
        p_admst clone=adms_admst_new(myadmst,d->_item);
        clone->_index=++count;
        adms_slist_push(&mylocation,adms_adms(clone));
        adms_slist_push(&myptraverse->_alladmst,adms_adms(clone));
        clone->_ori=d;
        clone->_pseudodatatype=d->_pseudodatatype;
        d->_refd++;
      }
    }
    if(mylocation&&mypath->_condition) mylocation=lcond2(myptraverse,mypath,mylocation);
    adms_slist_free(myptraverse->_admst);
    myptraverse->_admst=mylocation;
    adms_slist_inreverse(&myptraverse->_admst);
  }
}
_m_cblocation(Laroba)
{
  p_slist mylocation=NULL;
  int count=0;
  if((mode==2)&&!mypath->_condition)
  {
    p_slist myli=myptraverse->_admst;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_admstvariable aroba=lookup_aroba(myadmst,tsprintf(myadmst,mypath->_text));
      p_admst mynewadmst=adms_admst_new(myadmst,adms_adms(aroba));
      mynewadmst->_pseudodatatype=admse__dlist;
      myli->data=(p_adms)mynewadmst;
      adms_slist_push(&myptraverse->_alladmst,(p_adms)mynewadmst);
    }
  }
  else
  {
    p_slist myli=myptraverse->_admst;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_slist mylii;
      p_admstvariable aroba=lookup_aroba(myadmst,tsprintf(myadmst,mypath->_text));
      for(mylii=aroba->_value;mylii;mylii=mylii->next)
      {
        p_admst d=adms_admst(mylii->data);
        p_admst clone=adms_admst_new(myadmst,d->_item);
        clone->_index=++count;
        adms_slist_push(&mylocation,adms_adms(clone));
        adms_slist_push(&myptraverse->_alladmst,adms_adms(clone));
        clone->_ori=d;
        clone->_pseudodatatype=d->_pseudodatatype;
        d->_refd++;
      }
    }
    if(mylocation&&mypath->_condition) mylocation=lcond3(myptraverse,mypath,mylocation,count);
    adms_slist_free(myptraverse->_admst);
    myptraverse->_admst=mylocation;
    adms_slist_inreverse(&myptraverse->_admst);
  }
}
_m_cblocation(Root)
{
  p_admst myroot=adms_admst_new((p_admst)myptraverse->_admst->data,adms_adms(root()));
  myptraverse->_admst->data=(p_adms)myroot;
  adms_slist_push(&myptraverse->_alladmst,adms_adms(myroot));
}
_m_cblocation(Ldot)
{
  if(myptraverse->_admst&&mypath->_condition)
  {
    p_slist myli=myptraverse->_admst;
    p_slist prev=NULL;
    myptraverse->_admst=NULL;
    for(;myli;)
    {
      p_admst myadmst=adms_admst(myli->data);
      myadmst->_istrue=admse_yes;
      c00(adms_path(mypath->_condition->data),myadmst);
      if(myadmst->_istrue==admse_yes)
      {
        if(prev)
          prev->next=myli;
        else
          myptraverse->_admst=myli;
        prev=myli;
        myli=myli->next;
      }
      else
      {
        p_slist tmp=myli;
        myli=myli->next;
        free(tmp);
      }
    }
    if(prev)
      prev->next=NULL;
  }
}
_m_cblocation(Ldotdot)
{
  p_slist myli=myptraverse->_admst;
  if(mypath->_condition)
  {
    p_slist prev=NULL;
    myptraverse->_admst=NULL;
    for(;myli;)
    {
      p_admst myadmst=adms_admst(myli->data)->_previous;
      myli->data=adms_adms(myadmst);
      c00(adms_path(mypath->_condition->data),myadmst);
      if(myadmst->_istrue==admse_yes)
      {
        if(prev)
          prev->next=myli;
        else
          myptraverse->_admst=myli;
        prev=myli;
        myli=myli->next;
      }
      else
      {
        p_slist tmp=myli;
        myli=myli->next;
        free(tmp);
      }
    }
    if(prev)
      prev->next=NULL;
  }
  else
  {
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      myli->data=adms_adms(myadmst->_previous);
      myadmst->_previous->_istrue=admse_yes;
    }
  }
}
_m_cblocation(Lapplytemplates)
{
    p_slist myl;
    p_transform mytemplate=NULL;
    p_str match=tsprintf(NULL,mypath->_text);
    p_itransform myitransform;
    for(myl=root()->_template;myl&&!mytemplate;myl=myl->next)
    {
      p_transform curtemplate=adms_transform(myl->data);
      p_str id=((p_quark)curtemplate->_tmatch->_token->data)->_value;
      if(!strcmp(id,match))
        mytemplate=curtemplate;
    }
    if(mytemplate==NULL)
    {
      adms_message_fatal_continue((\"Template not found: %s\\n\",tsprintf(NULL,mypath->_text)))
      adms_message_fatal((\"  see:  %s\\n\",adms_transform_uid(mypath->_transform)))
    }
    //free(match);
    myitransform=adms_itransform_new(mytemplate);
    {
      int count=0;
      p_slist myli=myptraverse->_admst;
      p_slist mylocation=NULL;
      for(;myli;myli=myli->next)
      {
        p_admst myadmst=adms_admst(myli->data);
        p_ptraverse mysubptraverse0=ptraverse(0,myadmst,adms_path(mypath->_y->data));
        adms_slist_push(&root()->_itransform,adms_adms(myitransform));
        for(myl=(mysubptraverse0->_admst);myl;myl=myl->next)
        {
          if(myl->data&&adms_admst(myl->data)->_item)
          {
            p_slist mylii;
            xtraverse(mytemplate->_children,adms_admst(myl->data));
            for(mylii=myitransform->_variable;mylii;mylii=mylii->next)
            {
              p_admstvariable dollar=adms_admstvariable(mylii->data);
              p_slist myliii;
              for(myliii=dollar->_value;myliii;myliii=myliii->next)
                admst_free_when_unref(adms_admst(myliii->data));
              adms_quark_free(dollar->_name);
              adms_admstvariable_free(dollar);
            }
          }
        }
        adms_slist_pull(&root()->_itransform);
        free_ptraverse(0,mysubptraverse0);
        for(myl=myitransform->_return;myl;myl=myl->next)
        {
          p_admst d=adms_admst(myl->data);
          d->_index=++count;
          adms_slist_push(&mylocation,adms_adms(d));
          adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
        }
      }
      adms_slist_free(myptraverse->_admst);
      adms_slist_inreverse(&mylocation);
      if(mylocation&&mypath->_condition) myptraverse->_admst=lcond3(myptraverse,mypath,mylocation,count);
      else myptraverse->_admst=mylocation;
    }
    adms_itransform_free(myitransform);
}

static void L04datatypename(p_ptraverse myptraverse,p_path mypath)
{
  int count=0;
  p_slist myli=myptraverse->_admst;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(myadmst->_item->_datatypename));
    d->_index=++count;
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
    d->_pseudodatatype=admse_datatypename;
  }
  lcond1(myptraverse,mypath,count);
}
static void L04datatypefamily(p_ptraverse myptraverse,p_path mypath)
{
  int count=0;
  p_slist myli=myptraverse->_admst;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(adms_integer_new(0)));
    d->_index=++count;
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
    d->_pseudodatatype=admse__empty;
  }
  lcond1(myptraverse,mypath,count);
}
static void L04absolute(p_ptraverse myptraverse,p_path mypath)
{
  int count=0;
  p_slist myli=myptraverse->_admst;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(myadmst));
    d->_index=++count;
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
    d->_pseudodatatype=admse_admst;
  }
  lcond1(myptraverse,mypath,count);
}
static void L04istrue(p_ptraverse myptraverse,p_path mypath)
{
  int count=0;
  p_slist myli=myptraverse->_admst;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(adms_integer_new(myadmst->_istrue)));
    d->_index=++count;
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
    d->_hasnewitem=1;
    d->_pseudodatatype=admse__any;
  }
  lcond1(myptraverse,mypath,count);
}
";
}
my @l04=split "\n",$l04;
sub ident
{
my$e;
foreach (@l04)
{
if(/IFIDENT\((\w+)\)/)
{
$e=$1;
}
if(/MKSCALAR\((\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    {
      p_admst d=adms_admst_new(myadmst,adms_adms((adms_$1(myadmst->_item)->_$2)));
      d->_index=++count;
      myli->data=(p_adms)d;
      adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
      d->_pseudodatatype=admse__any;
      d->_valueto=adms_$1_valueto_$2;
    }
  }
  lcond1(myptraverse,mypath,count);
}
";
}
if(/MKBASICINTEGER\((\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    {
      p_admst d=adms_admst_new(myadmst,adms_adms((adms_$1(myadmst->_item)->_$2)));
      d->_index=++count;
      myli->data=(p_adms)d;
      adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
      d->_pseudodatatype=admse__basicinteger;
      d->_valueto=adms_$1_valueto_$2;
    }
  }
  lcond1(myptraverse,mypath,count);
}
";
}
if(/MKRETURNED\((\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst d=adms_admst(myli->data);
    ++count;
    d->_pseudodatatype=admse__returned$2;
    d->_valueto=adms_$1_valueto_$2;
  }
  lcond1(myptraverse,mypath,count);
}
";
}
if(/MKREAL\((\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    {
      p_admst d=adms_admst_new(myadmst,myadmst->_item);
      d->_index=++count;
      myli->data=(p_adms)d;
      adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
      d->_pseudodatatype=admse_real;
      d->_valueto=adms_real_valueto_value;
    }
  }
  lcond1(myptraverse,mypath,count);
}
";
}
if(/MKLIST\((\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath,int mode)
{
  if((mode==2)&&!mypath->_condition)
  {
    p_slist myli=myptraverse->_admst;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_admst mynewadmst=adms_admst_new(myadmst,adms_adms(adms_$1(myadmst->_item)->_$2));
      mynewadmst->_valueto=adms_$1_valueto_$2;
      mynewadmst->_pseudodatatype=admse__elist;
      myli->data=(p_adms)mynewadmst;
      adms_slist_push(&myptraverse->_alladmst,(p_adms)mynewadmst);
    }
  }
  else
  {
    int count=0;
    p_slist mylocation=NULL;
    p_slist myli=myptraverse->_admst;
    for(;myli;myli=myli->next)
    {
      p_admst myadmst=adms_admst(myli->data);
      p_slist mylii=adms_$1(myadmst->_item)->_$2;
      for(;mylii;mylii=mylii->next)
      {
        p_admst d=adms_admst_new(myadmst,adms_adms(mylii->data));
        d->_index=++count;
        adms_slist_push(&mylocation,adms_adms(d));
        adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
        d->_pseudodatatype=admse__any;
      }
    }
    if(mylocation&&mypath->_condition) mylocation=lcond3(myptraverse,mypath,mylocation,count);
    adms_slist_free(myptraverse->_admst);
    myptraverse->_admst=mylocation;
    adms_slist_inreverse(&myptraverse->_admst);
  }
}
";
}
if(/MKSUBADMS\((\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(myadmst->_item)); 
    d->_index=++count; 
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d)); 
    d->_pseudodatatype=admse__empty; 
    d->_pseudodatatype=admse_$2; 
    d->_valueto=adms_$1_valueto_$2; 
  }
  lcond1(myptraverse,mypath,count);
}
"
}
if(/MKALIAS\((\w+),(\w+),(\w+),(\w+)\)/)
{
print CFILE "static void l04$1$e\(p_ptraverse myptraverse,p_path mypath)
{
  p_slist myli=myptraverse->_admst;
  int count=0;
  for(;myli;myli=myli->next)
  {
    p_admst myadmst=adms_admst(myli->data);
    p_admst d=adms_admst_new(myadmst,adms_adms(adms_$3(myadmst->_item)->_$4));
    d->_index=++count;
    myli->data=(p_adms)d;
    adms_slist_push(&myptraverse->_alladmst,adms_adms(d));
    d->_pseudodatatype=admse__any;
    d->_valueto=adms_$3_valueto_$4;
  }
  lcond1(myptraverse,mypath,count);
}
";
}
if(/ENDIFIDENT/)
{
  print CFILE "";
}
}
foreach (@l04)
{
if(/IFIDENT\((\w+)\)/)
{
$e=$1;
print CFILE "static void L04$e\(p_ptraverse myptraverse,p_path mypath,int mode)
{
  p_admst myfirstadmst;
  admse e=0;
  if(myptraverse->_admst&&(myfirstadmst=(p_admst)myptraverse->_admst->data)&&(myfirstadmst->_item))
    e=(myfirstadmst->_pseudodatatype==admse__any)?myfirstadmst->_item->_datatypename:myfirstadmst->_pseudodatatype;
  if(e==0) {}
";
}
if(/MKRETURNED\((\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/MKSCALAR\((\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/MKBASICINTEGER\((\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/MKALIASSCALAR\((\w+),(\w+),(\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$3) l04$1$e(myptraverse,mypath);\n"; }
if(/MKREAL\((\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/MKLIST\((\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath,mode);\n"; }
if(/MKSUBADMS\((\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/MKALIAS\((\w+),(\w+),(\w+),(\w+)\)/) { print CFILE "  else if(e==admse_$1) l04$1$e(myptraverse,mypath);\n"; }
if(/ENDIFIDENT/) { print CFILE "\}\n"; }
}
}

my@location=qw(position positionplus positionminus posinteger neginteger posreal negreal count index quotedstring
id uid string upper_case lower_case sort reverse number contains text admst returned croix star);

print CFILE "\n";
&list;
&ident;
foreach(@location)
{
  my$cb=$_;
  my$code=q[
_m_cblocation(LFUNCTION)
{
  CODE}];
  my$newbody;
  if(not $location{$cb})
  {
    $nosupp="  adms_message_fatal_continue((\"$cb(): not supported!\\n\"))\n";
    $nosupp.="  adms_message_fatal((\"see %s\\n\",adms_transform_uid(mypath->_transform)))\n";
    print CFILE "\n_m_cblocation(L$cb)\n{\n$nosupp}";
    next;
  }
  my$body=$location{$cb};
  my@body=split "\n", $body if $body;
  foreach(@body)
  {
    if(/(\s+)FORBEGIN/)
    {
      $newbody.="$1int count=0;\n";
      $newbody.="$1p_slist myli=myptraverse->_admst;\n";
      if(/(\s+)FORBEGIN-NULL/)
      {
        $newbody.="$1p_slist prev=NULL;\n";
        $newbody.="$1myptraverse->_admst=NULL;\n";
      }
      $newbody.="$1for(;myli;myli=myli->next)\n";
      $newbody.="$1\{\n";
      $newbody.="$1  p_admst myadmst=adms_admst(myli->data);\n";
    }
    elsif(/(\s+)MKADMST(NEW)?\((.*)\)/)
    {
      $newbody.="$1\{\n";
      $newbody.="$1  p_admst d=adms_admst_new(myadmst,adms_adms($3));\n";
      $newbody.="$1  d->_index=++count;\n";
      $newbody.="$1  myli->data=adms_adms(d);\n";
      $newbody.="$1  adms_slist_push(&myptraverse->_alladmst,adms_adms(d));\n";
      $newbody.="$1  d->_pseudodatatype=admse__croix;\n" if $cb eq "croix";
      $newbody.="$1  d->_hasnewitem=1;\n" if $2;
      $newbody.="$1\}\n";
    }
    elsif(/(\s+)FOREND/)
    {
      $newbody.="$1}\n";
      $newbody.="  lcond1(myptraverse,mypath,count);\n";
    }
    else
    {
      $newbody.="$_\n";
    }
  }
  $code=~s/FUNCTION/$_/;
  $code=~s/CODE/$newbody/;
  print CFILE $code;
}
print CFILE "\n";

close CFILE;
print "admstpath.c: created\n";
